Index: branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsed.F90
===================================================================
--- branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsed.F90	(revision 2822)
+++ branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsed.F90	(revision 2823)
@@ -360,95 +381,182 @@
 
       !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE p4z_sed_init  ***
-      !!
-      !! ** Purpose :   Initialization of the external sources of nutrients
-      !!
-      !! ** Method  :   Read the files and compute the budget
-      !!      called at the first timestep (nit000)
+      !!                  ***  routine p4z_sed_init  ***
+      !!
+      !! ** purpose :   initialization of the external sources of nutrients
+      !!
+      !! ** method  :   read the files and compute the budget
+      !!                called at the first timestep (nit000)
       !!
       !! ** input   :   external netcdf files
       !!
       !!----------------------------------------------------------------------
-      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
-      USE wrk_nemo, ONLY: zriverdoc => wrk_2d_1, zriver => wrk_2d_2, zndepo => wrk_2d_3
-      USE wrk_nemo, ONLY: zcmask => wrk_3d_2
       !
-      INTEGER :: ji, jj, jk, jm
-      INTEGER :: numriv, numbath, numdep
-      REAL(wp) ::   zcoef
-      REAL(wp) ::   expide, denitide,zmaskt
+      INTEGER  :: ji, jj, jk, jm
+      INTEGER  :: numdust, numriv, numiron, numdepo
+      INTEGER  :: ierr, ierr1, ierr2, ierr3
+      REAL(wp) :: zexpide, zdenitide, zmaskt
+      REAL(wp), DIMENSION(nbtimes) :: zsteps                 ! times records
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: zdust, zndepo, zriverdic, zriverdoc, zcmask
       !
-      NAMELIST/nampissed/ ln_dustfer, ln_river, ln_ndepo, ln_sedinput, sedfeinput, dustsolub
+      CHARACTER(len=100) ::  cn_dir          ! Root directory for location of ssr files
+      TYPE(FLD_N) ::   sn_dust, sn_riverdoc, sn_riverdic, sn_ndepo, sn_ironsed        ! informations about the fields to be read
+      NAMELIST/nampissed/cn_dir, sn_dust, sn_riverdic, sn_riverdoc, sn_ndepo, sn_ironsed, &
+        &                ln_dust, ln_river, ln_ndepo, ln_ironsed,         &
+        &                sedfeinput, dustsolub, wdust, nitrfix, diazolight, concfediaz 
       !!----------------------------------------------------------------------
-
-      IF( ( wrk_in_use(2, 1,2,3) ) .OR. ( wrk_in_use(3, 2) ) ) THEN
-         CALL ctl_stop('p4z_sed_init: requested workspace arrays unavailable')  ;  RETURN
-      END IF
-      !
-      REWIND( numnat )                     ! read numnat
-      READ  ( numnat, nampissed )
+      !                                    ! number of seconds per year and per month
+      ryyss    = nyear_len(1) * rday
+      rmtss    = ryyss / raamo
+      r1_rday  = 1. / rday
+      r1_ryyss = 1. / ryyss
+      !                            !* set file information
+      cn_dir  = './'            ! directory in which the model is executed
+      ! ... default values (NB: frequency positive => hours, negative => months)
+      !                  !   file       ! frequency !  variable   ! time intep !  clim   ! 'yearly' or ! weights  ! rotation   !
+      !                  !   name       !  (hours)  !   name      !   (T/F)    !  (T/F)  !  'monthly'  ! filename ! pairs      !
+      sn_dust     = FLD_N( 'dust'       ,    -1     ,  'dust'     ,  .true.    , .true.  ,   'yearly'  , ''       , ''         )
+      sn_riverdic = FLD_N( 'river'      ,   -12     ,  'riverdic' ,  .false.   , .true.  ,   'yearly'  , ''       , ''         )
+      sn_riverdoc = FLD_N( 'river'      ,   -12     ,  'riverdoc' ,  .false.   , .true.  ,   'yearly'  , ''       , ''         )
+      sn_ndepo    = FLD_N( 'ndeposition',   -12     ,  'ndep'     ,  .false.   , .true.  ,   'yearly'  , ''       , ''         )
+      sn_ironsed  = FLD_N( 'ironsed'    ,   -12     ,  'bathy'    ,  .false.   , .true.  ,   'yearly'  , ''       , ''         )
+
+
+      REWIND( numnatp )                     ! read numnat
+      READ  ( numnatp, nampissed )
 
       IF(lwp) THEN
          WRITE(numout,*) ' '
-         WRITE(numout,*) ' Namelist : nampissed '
+         WRITE(numout,*) ' namelist : nampissed '
          WRITE(numout,*) ' ~~~~~~~~~~~~~~~~~ '
-         WRITE(numout,*) '    Dust input from the atmosphere           ln_dustfer  = ', ln_dustfer
-         WRITE(numout,*) '    River input of nutrients                 ln_river    = ', ln_river
-         WRITE(numout,*) '    Atmospheric deposition of N              ln_ndepo    = ', ln_ndepo
-         WRITE(numout,*) '    Fe input from sediments                  ln_sedinput = ', ln_sedinput
-         WRITE(numout,*) '    Coastal release of Iron                  sedfeinput  =', sedfeinput
-         WRITE(numout,*) '    Solubility of the dust                   dustsolub   =', dustsolub
-      ENDIF
-
-      ! Dust input from the atmosphere
+         WRITE(numout,*) '    dust input from the atmosphere           ln_dust     = ', ln_dust
+         WRITE(numout,*) '    river input of nutrients                 ln_river    = ', ln_river
+         WRITE(numout,*) '    atmospheric deposition of n              ln_ndepo    = ', ln_ndepo
+         WRITE(numout,*) '    fe input from sediments                  ln_sedinput = ', ln_ironsed
+         WRITE(numout,*) '    coastal release of iron                  sedfeinput  = ', sedfeinput
+         WRITE(numout,*) '    solubility of the dust                   dustsolub   = ', dustsolub
+         WRITE(numout,*) '    sinking speed of the dust                wdust       = ', wdust
+         WRITE(numout,*) '    nitrogen fixation rate                   nitrfix     = ', nitrfix
+         WRITE(numout,*) '    nitrogen fixation sensitivty to light    diazolight  = ', diazolight
+         WRITE(numout,*) '    fe half-saturation cste for diazotrophs  concfediaz  = ', concfediaz
+       END IF
+
+      IF( ln_dust .OR. ln_river .OR. ln_ndepo ) THEN
+          ll_sbc = .TRUE.
+      ELSE
+          ll_sbc = .FALSE.
+      ENDIF
+
+      ! dust input from the atmosphere
       ! ------------------------------
-      IF( ln_dustfer ) THEN 
-         IF(lwp) WRITE(numout,*) '    Initialize dust input from atmosphere '
+      IF( ln_dust ) THEN 
+         IF(lwp) WRITE(numout,*) '    initialize dust input from atmosphere '
          IF(lwp) WRITE(numout,*) '    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ '
-         CALL iom_open ( 'dust.orca.nc', numdust )
-         DO jm = 1, jpmth
-            CALL iom_get( numdust, jpdom_data, 'dust', dustmo(:,:,jm), jm )
+         !
+         ALLOCATE( sf_dust(1), STAT=ierr )           !* allocate and fill sf_sst (forcing structure) with sn_sst
+         IF( ierr > 0 )   CALL ctl_stop( 'STOP', 'p4z_sed_init: unable to allocate sf_apr structure' )
+         !
+         CALL fld_fill( sf_dust, (/ sn_dust /), cn_dir, 'p4z_sed_init', 'Iron from sediment ', 'nampissed' )
+                                   ALLOCATE( sf_dust(1)%fnow(jpi,jpj,1)   )
+         IF( sn_dust%ln_tint )     ALLOCATE( sf_dust(1)%fdta(jpi,jpj,1,2) )
+         !
+         ! Get total input dust ; need to compute total atmospheric supply of Si in a year
+         CALL iom_open (  TRIM( sn_dust%clname ) , numdust )
+         CALL iom_gettime( numdust, zsteps, kntime=ntimes_dust)  ! get number of record in file
+         ALLOCATE( zdust(jpi,jpj,ntimes_dust) )
+         DO jm = 1, ntimes_dust
+            CALL iom_get( numdust, jpdom_data, TRIM( sn_dust%clvar ), zdust(:,:,jm), jm )
          END DO
          CALL iom_close( numdust )
+         sumdepsi = 0.e0
+         DO jm = 1, ntimes_dust
+            sumdepsi = sumdepsi + glob_sum( zdust(:,:,jm) * e1e2t(:,:) * tmask(:,:,1) ) 
+         ENDDO
+         sumdepsi = sumdepsi * r1_ryyss * 8.8 * 0.075 / 28.1 
+         DEALLOCATE( zdust)
       ELSE
-         dustmo(:,:,:) = 0.e0
-         dust(:,:) = 0.0
-      ENDIF
-
-      ! Nutrient input from rivers
+         dust(:,:) = 0._wp
+         sumdepsi  = 0._wp
+      END IF
+
+      ! nutrient input from rivers
       ! --------------------------
       IF( ln_river ) THEN
-         IF(lwp) WRITE(numout,*) '    Initialize the nutrient input by rivers from river.orca.nc file'
-         IF(lwp) WRITE(numout,*) '    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
-         CALL iom_open ( 'river.orca.nc', numriv )
-         CALL iom_get  ( numriv, jpdom_data, 'riverdic', zriver   (:,:), jpyr )
-         CALL iom_get  ( numriv, jpdom_data, 'riverdoc', zriverdoc(:,:), jpyr )
+         ALLOCATE( sf_riverdic(1), STAT=ierr1 )           !* allocate and fill sf_sst (forcing structure) with sn_sst
+         ALLOCATE( sf_riverdoc(1), STAT=ierr2 )           !* allocate and fill sf_sst (forcing structure) with sn_sst
+         IF( ierr1 + ierr2 > 0 )   CALL ctl_stop( 'STOP', 'p4z_sed_init: unable to allocate sf_apr structure' )
+         !
+         CALL fld_fill( sf_riverdic, (/ sn_riverdic /), cn_dir, 'p4z_sed_init', 'Input DOC from river ', 'nampissed' )
+         CALL fld_fill( sf_riverdoc, (/ sn_riverdoc /), cn_dir, 'p4z_sed_init', 'Input DOC from river ', 'nampissed' )
+                                   ALLOCATE( sf_riverdic(1)%fnow(jpi,jpj,1)   )
+                                   ALLOCATE( sf_riverdoc(1)%fnow(jpi,jpj,1)   )
+         IF( sn_riverdic%ln_tint ) ALLOCATE( sf_riverdic(1)%fdta(jpi,jpj,1,2) )
+         IF( sn_riverdoc%ln_tint ) ALLOCATE( sf_riverdoc(1)%fdta(jpi,jpj,1,2) )
+         ! Get total input rivers ; need to compute total river supply in a year
+         CALL iom_open ( TRIM( sn_riverdic%clname ), numriv )
+         CALL iom_gettime( numriv, zsteps, kntime=ntimes_riv)
+         ALLOCATE( zriverdic(jpi,jpj,ntimes_riv) )   ;     ALLOCATE( zriverdoc(jpi,jpj,ntimes_riv) )
+         DO jm = 1, ntimes_riv
+            CALL iom_get( numriv, jpdom_data, TRIM( sn_riverdic%clvar ), zriverdic(:,:,jm), jm )
+            CALL iom_get( numriv, jpdom_data, TRIM( sn_riverdoc%clvar ), zriverdoc(:,:,jm), jm )
+         END DO
          CALL iom_close( numriv )
+         ! N/P and Si releases due to coastal rivers
+         ! -----------------------------------------
+         rivpo4input = 0._wp 
+         rivalkinput = 0._wp 
+         DO jm = 1, ntimes_riv
+            rivpo4input = rivpo4input + glob_sum( ( zriverdic(:,:,jm) + zriverdoc(:,:,jm) ) * tmask(:,:,1) ) 
+            rivalkinput = rivalkinput + glob_sum(   zriverdic(:,:,jm)                       * tmask(:,:,1) ) 
+         END DO
+         rivpo4input = rivpo4input * 1E9 / 31.6_wp
+         rivalkinput = rivalkinput * 1E9 / 12._wp 
+         DEALLOCATE( zriverdic)   ;    DEALLOCATE( zriverdoc) 
       ELSE
-         zriver   (:,:) = 0.e0
-         zriverdoc(:,:) = 0.e0
-      endif
-
-      ! Nutrient input from dust
+         rivinp(:,:) = 0._wp
+         cotdep(:,:) = 0._wp
+         rivpo4input = 0._wp
+         rivalkinput = 0._wp
+      END IF 
+
+      ! nutrient input from dust
       ! ------------------------
       IF( ln_ndepo ) THEN
-         IF(lwp) WRITE(numout,*) '    Initialize the nutrient input by dust from ndeposition.orca.nc'
+         IF(lwp) WRITE(numout,*) '    initialize the nutrient input by dust from ndeposition.orca.nc'
          IF(lwp) WRITE(numout,*) '    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
-         CALL iom_open ( 'ndeposition.orca.nc', numdep )
-         CALL iom_get  ( numdep, jpdom_data, 'ndep', zndepo(:,:), jpyr )
-         CALL iom_close( numdep )
+         ALLOCATE( sf_ndepo(1), STAT=ierr3 )           !* allocate and fill sf_sst (forcing structure) with sn_sst
+         IF( ierr3 > 0 )   CALL ctl_stop( 'STOP', 'p4z_sed_init: unable to allocate sf_apr structure' )
+         !
+         CALL fld_fill( sf_ndepo, (/ sn_ndepo /), cn_dir, 'p4z_sed_init', 'Iron from sediment ', 'nampissed' )
+                                   ALLOCATE( sf_ndepo(1)%fnow(jpi,jpj,1)   )
+         IF( sn_ndepo%ln_tint )    ALLOCATE( sf_ndepo(1)%fdta(jpi,jpj,1,2) )
+         !
+         ! Get total input dust ; need to compute total atmospheric supply of N in a year
+         CALL iom_open ( TRIM( sn_ndepo%clname ), numdepo )
+         CALL iom_gettime( numdepo, zsteps, kntime=ntimes_ndep)
+         ALLOCATE( zndepo(jpi,jpj,ntimes_ndep) )
+         DO jm = 1, ntimes_ndep
+            CALL iom_get( numdepo, jpdom_data, TRIM( sn_ndepo%clvar ), zndepo(:,:,jm), jm )
+         END DO
+         CALL iom_close( numdepo )
+         nitdepinput = 0._wp
+         DO jm = 1, ntimes_ndep
+           nitdepinput = nitdepinput + glob_sum( zndepo(:,:,jm) * e1e2t(:,:) * tmask(:,:,1) ) 
+         ENDDO
+         nitdepinput = nitdepinput * 7.6 / 14E6 
+         DEALLOCATE( zndepo)
       ELSE
-         zndepo(:,:) = 0.e0
-      ENDIF
-
-      ! Coastal and island masks
+         nitdep(:,:) = 0._wp
+         nitdepinput = 0._wp
+      ENDIF
+
+      ! coastal and island masks
       ! ------------------------
-      IF( ln_sedinput ) THEN     
-         IF(lwp) WRITE(numout,*) '    Computation of an island mask to enhance coastal supply of iron'
+      IF( ln_ironsed ) THEN     
+         IF(lwp) WRITE(numout,*) '    computation of an island mask to enhance coastal supply of iron'
          IF(lwp) WRITE(numout,*) '    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
-         IF(lwp) WRITE(numout,*) '       from bathy.orca.nc file '
-         CALL iom_open ( 'bathy.orca.nc', numbath )
-         CALL iom_get  ( numbath, jpdom_data, 'bathy', zcmask(:,:,:), jpyr )
-         CALL iom_close( numbath )
+         CALL iom_open ( TRIM( sn_ironsed%clname ), numiron )
+         ALLOCATE( zcmask(jpi,jpj,jpk) )
+         CALL iom_get  ( numiron, jpdom_data, TRIM( sn_ironsed%clvar ), zcmask(:,:,:), 1 )
+         CALL iom_close( numiron )
          !
          DO jk = 1, 5
@@ -459,67 +567,44 @@
                         &                       * tmask(ji,jj-1,jk) * tmask(ji,jj,jk+1)
                      IF( zmaskt == 0. )   zcmask(ji,jj,jk ) = MAX( 0.1, zcmask(ji,jj,jk) ) 
-                  ENDIF
+                  END IF
                END DO
             END DO
          END DO
+         CALL lbc_lnk( zcmask , 'T', 1. )      ! lateral boundary conditions on cmask   (sign unchanged)
          DO jk = 1, jpk
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  expide   = MIN( 8.,( fsdept(ji,jj,jk) / 500. )**(-1.5) )
-                  denitide = -0.9543 + 0.7662 * LOG( expide ) - 0.235 * LOG( expide )**2
-                  zcmask(ji,jj,jk) = zcmask(ji,jj,jk) * MIN( 1., EXP( denitide ) / 0.5 )
+                  zexpide   = MIN( 8.,( fsdept(ji,jj,jk) / 500. )**(-1.5) )
+                  zdenitide = -0.9543 + 0.7662 * LOG( zexpide ) - 0.235 * LOG( zexpide )**2
+                  zcmask(ji,jj,jk) = zcmask(ji,jj,jk) * MIN( 1., EXP( zdenitide ) / 0.5 )
                END DO
             END DO
          END DO
+         ! Coastal supply of iron
+         ! -------------------------
+         ironsed(:,:,jpk) = 0._wp
+         DO jk = 1, jpkm1
+            ironsed(:,:,jk) = sedfeinput * zcmask(:,:,jk) / ( fse3t(:,:,jk) * rday )
+         END DO
+         DEALLOCATE( zcmask)
       ELSE
-         zcmask(:,:,:) = 0.e0
-      ENDIF
-
-      CALL lbc_lnk( zcmask , 'T', 1. )      ! Lateral boundary conditions on zcmask   (sign unchanged)
-
-
-      !                                    ! Number of seconds per year and per month
-      ryyss  = nyear_len(1) * rday
-      rmtss  = ryyss / raamo
-      rday1  = 1. / rday
-      ryyss1 = 1. / ryyss
-      !                                    ! ocean surface cell
-
-      ! total atmospheric supply of Si
-      ! ------------------------------
-      sumdepsi = 0.e0
-      DO jm = 1, jpmth
-         zcoef = 1. / ( 12. * rmtss ) * 8.8 * 0.075 / 28.1        
-         sumdepsi = sumdepsi + glob_sum( dustmo(:,:,jm) * e1e2t(:,:) ) * zcoef
-      ENDDO
-
-      ! N/P and Si releases due to coastal rivers
-      ! -----------------------------------------
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            zcoef = ryyss * e1e2t(ji,jj)  * fse3t(ji,jj,1) * tmask(ji,jj,1) 
-            cotdep(ji,jj) =  zriver(ji,jj)                  *1E9 / ( 12. * zcoef + rtrn )
-            rivinp(ji,jj) = (zriver(ji,jj)+zriverdoc(ji,jj)) *1E9 / ( 31.6* zcoef + rtrn )
-            nitdep(ji,jj) = 7.6 * zndepo(ji,jj)                  / ( 14E6*ryyss*fse3t(ji,jj,1) + rtrn )
-         END DO
-      END DO
-      ! Lateral boundary conditions on ( cotdep, rivinp, nitdep )   (sign unchanged)
-      CALL lbc_lnk( cotdep , 'T', 1. )  ;  CALL lbc_lnk( rivinp , 'T', 1. )  ;  CALL lbc_lnk( nitdep , 'T', 1. )
-
-      rivpo4input = glob_sum( rivinp(:,:) * cvol(:,:,1) ) * ryyss
-      rivalkinput = glob_sum( cotdep(:,:) * cvol(:,:,1) ) * ryyss
-      nitdepinput = glob_sum( nitdep(:,:) * cvol(:,:,1) ) * ryyss
-
-
-      ! Coastal supply of iron
-      ! -------------------------
-      DO jk = 1, jpkm1
-         ironsed(:,:,jk) = sedfeinput * zcmask(:,:,jk) / ( fse3t(:,:,jk) * rday )
-      END DO
-      CALL lbc_lnk( ironsed , 'T', 1. )      ! Lateral boundary conditions on ( ironsed )   (sign unchanged)
-
-      IF( ( wrk_not_released(2, 1,2,3) ) .OR. ( wrk_not_released(3, 2) ) )   &
-        &         CALL ctl_stop('p4z_sed_init: failed to release workspace arrays')
-
+         ironsed(:,:,:) = 0._wp
+      ENDIF
+      !
+      IF(lwp) THEN 
+         WRITE(numout,*)
+         WRITE(numout,*) '    Total input of elements from river supply'
+         WRITE(numout,*) '    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
+         WRITE(numout,*) '    N Supply   : ', rivpo4input/7.6*1E3/1E12*14.,' TgN/yr'
+         WRITE(numout,*) '    Si Supply  : ', rivalkinput/6.*1E3/1E12*32.,' TgSi/yr'
+         WRITE(numout,*) '    Alk Supply : ', rivalkinput*1E3/1E12,' Teq/yr'
+         WRITE(numout,*) '    DIC Supply : ', rivpo4input*2.631*1E3*12./1E12,'TgC/yr'
+         WRITE(numout,*) 
+         WRITE(numout,*) '    Total input of elements from atmospheric supply'
+         WRITE(numout,*) '    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
+         WRITE(numout,*) '    N Supply   : ', nitdepinput/7.6*1E3/1E12*14.,' TgN/yr'
+         WRITE(numout,*) 
+      ENDIF
+       !
    END SUBROUTINE p4z_sed_init
 
@@ -529,7 +614,6 @@
       !!----------------------------------------------------------------------
 
-      ALLOCATE( dustmo(jpi,jpj,jpmth), dust(jpi,jpj)       ,     &
-        &       rivinp(jpi,jpj)      , cotdep(jpi,jpj)     ,     &
-        &       nitdep(jpi,jpj)      , ironsed(jpi,jpj,jpk), STAT=p4z_sed_alloc )  
+      ALLOCATE( dust  (jpi,jpj), rivinp(jpi,jpj)     , cotdep(jpi,jpj),      &
+        &       nitdep(jpi,jpj), ironsed(jpi,jpj,jpk), STAT=p4z_sed_alloc )  
 
       IF( p4z_sed_alloc /= 0 ) CALL ctl_warn('p4z_sed_alloc : failed to allocate arrays.')
Index: branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsink.F90
===================================================================
--- branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsink.F90	(revision 2822)
+++ branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsink.F90	(revision 2823)
@@ -6,13 +6,15 @@
    !! History :   1.0  !  2004     (O. Aumont) Original code
    !!             2.0  !  2007-12  (C. Ethe, G. Madec)  F90
+   !!             3.4  !  2011-06  (O. Aumont, C. Ethe) Change aggregation formula
+   !!----------------------------------------------------------------------
 #if defined key_pisces
    !!----------------------------------------------------------------------
    !!   p4z_sink       :  Compute vertical flux of particulate matter due to gravitational sinking
    !!----------------------------------------------------------------------
-   USE trc
-   USE oce_trc         !
-   USE sms_pisces
-   USE prtctl_trc
-   USE iom
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
+   USE prtctl_trc      !  print control for debugging
+   USE iom             !  I/O manager
 
    IMPLICIT NONE
@@ -91,8 +93,6 @@
       REAL(wp) :: zdiv , zdiv1, zdiv2, zdiv3, zdiv4, zdiv5
       REAL(wp) :: zval1, zval2, zval3, zval4
-#if defined key_diatrc
       REAL(wp) :: zrfact2
       INTEGER  :: ik1
-#endif
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
@@ -193,11 +193,7 @@
                      &            * (zeps-1)/zdiv1 + 3.*(zfm*xkr_mass_max-xkr_mass_min)    &
                      &            * (zfm*xkr_mass_max**2-xkr_mass_min**2)                  &
-                     &            * (zeps-1.)**2/(zdiv2*zdiv3))            &
-# if defined key_degrad
-                     &                 *facvol(ji,jj,jk)       &
-# endif
-                     &    )
-
-                  zagg2 = (  2*0.163*trn(ji,jj,jk,jpnum)**2*zfm*                       &
+                     &            * (zeps-1.)**2/(zdiv2*zdiv3))       
+
+                  zagg2 =  2*0.163*trn(ji,jj,jk,jpnum)**2*zfm*                       &
                      &                   ((xkr_mass_max**3+3.*(xkr_mass_max**2          &
                      &                    *xkr_mass_min*(zeps-1.)/zdiv2                 &
@@ -205,17 +201,7 @@
                      &                    +xkr_mass_min**3*(zeps-1)/zdiv1)                  &
                      &                    -zfm*xkr_mass_max**3*(1.+3.*((zeps-1.)/           &
-                     &                    (zeps-2.)+(zeps-1.)/zdiv3)+(zeps-1.)/zdiv1))      &
-#    if defined key_degrad
-                     &                 *facvol(ji,jj,jk)             &
-#    endif
-                     &    )
-
-                  zagg3 = (  0.163*trn(ji,jj,jk,jpnum)**2*zfm**2*8. * xkr_mass_max**3   &
-#    if defined key_degrad
-                     &                 *facvol(ji,jj,jk)             &
-#    endif
-                     &    )
-
-                  zaggsh = ( zagg1 + zagg2 + zagg3 ) * rfact2 * xdiss(ji,jj,jk) / 1000.
+                     &                    (zeps-2.)+(zeps-1.)/zdiv3)+(zeps-1.)/zdiv1))    
+
+                  zagg3 =  0.163*trn(ji,jj,jk,jpnum)**2*zfm**2*8. * xkr_mass_max**3  
 
                  !    Aggregation of small into large particles
@@ -223,24 +209,16 @@
                  !    ----------------------------------------------
 
-                  zagg4 = (  2.*3.141*0.125*trn(ji,jj,jk,jpnum)**2*                       &
+                  zagg4 =  2.*3.141*0.125*trn(ji,jj,jk,jpnum)**2*                       &
                      &                 xkr_wsbio_min*(zeps-1.)**2                         &
                      &                 *(xkr_mass_min**2*((1.-zsm*zfm)/(zdiv3*zdiv4)      &
                      &                 -(1.-zfm)/(zdiv*(zeps-1.)))-                       &
                      &                 ((zfm*zfm*xkr_mass_max**2*zsm-xkr_mass_min**2)     &
-                     &                 *xkr_eta)/(zdiv*zdiv3*zdiv5) )                     &
-# if defined key_degrad
-                     &                 *facvol(ji,jj,jk)        &
-# endif
-                     &    )
-
-                  zagg5 = (  2.*3.141*0.125*trn(ji,jj,jk,jpnum)**2                         &
+                     &                 *xkr_eta)/(zdiv*zdiv3*zdiv5) )   
+
+                  zagg5 =   2.*3.141*0.125*trn(ji,jj,jk,jpnum)**2                         &
                      &                 *(zeps-1.)*zfm*xkr_wsbio_min                        &
                      &                 *(zsm*(xkr_mass_min**2-zfm*xkr_mass_max**2)         &
                      &                 /zdiv3-(xkr_mass_min**2-zfm*zsm*xkr_mass_max**2)    &
-                     &                 /zdiv)                   &
-# if defined key_degrad
-                     &                 *facvol(ji,jj,jk)        &
-# endif
-                     &    )
+                     &                 /zdiv)  
 
                   zaggsi = ( zagg4 + zagg5 ) * xstep / 10.
@@ -253,9 +231,18 @@
                   zaggdoc = ( 0.4 * trn(ji,jj,jk,jpdoc)               &
                      &        + 1018.  * trn(ji,jj,jk,jppoc)  ) * xstep    &
+                     &        * xdiss(ji,jj,jk) * trn(ji,jj,jk,jpdoc)
+
 # if defined key_degrad
-                     &        * facvol(ji,jj,jk)                              &
+                   zagg1   = zagg1   * facvol(ji,jj,jk)                 
+                   zagg2   = zagg2   * facvol(ji,jj,jk)                 
+                   zagg3   = zagg3   * facvol(ji,jj,jk)                 
+                   zagg4   = zagg4   * facvol(ji,jj,jk)                 
+                   zagg5   = zagg5   * facvol(ji,jj,jk)                 
+                   zaggdoc = zaggdoc * facvol(ji,jj,jk)                 
 # endif
-                     &        * xdiss(ji,jj,jk) * trn(ji,jj,jk,jpdoc)
-
+                  zaggsh = ( zagg1 + zagg2 + zagg3 ) * rfact2 * xdiss(ji,jj,jk) / 1000.
+                  zaggsi = ( zagg4 + zagg5 ) * xstep / 10.
+                  zagg = 0.5 * xkr_stick * ( zaggsh + zaggsi )
+                  !
                   znumdoc = trn(ji,jj,jk,jpnum) / ( trn(ji,jj,jk,jppoc) + rtrn )
                   tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) + zaggdoc
@@ -335,6 +322,6 @@
       !!----------------------------------------------------------------------
       !
-      REWIND( numnat )                     ! read nampiskrs
-      READ  ( numnat, nampiskrs )
+      REWIND( numnatp )                     ! read nampiskrs
+      READ  ( numnat,( nampiskrs )
 
       IF(lwp) THEN
@@ -457,10 +444,8 @@
       INTEGER  ::   ji, jj, jk
       REAL(wp) ::   zagg1, zagg2, zagg3, zagg4
-      REAL(wp) ::   zagg , zaggfe, zaggdoc, zaggdoc2
-      REAL(wp) ::   zfact, zwsmax, zstep
-#if defined key_diatrc
+      REAL(wp) ::   zagg , zaggfe, zaggdoc, zaggdoc2, zaggdoc3
+      REAL(wp) ::   zfact, zwsmax, zmax, zstep
       REAL(wp) ::   zrfact2
       INTEGER  ::   ik1
-#endif
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
@@ -471,6 +456,7 @@
       DO jk = 1, jpkm1
          DO jj = 1, jpj
-            DO ji=1,jpi
-               zfact = MAX( 0., fsdepw(ji,jj,jk+1) - hmld(ji,jj) ) / 4000._wp
+            DO ji = 1,jpi
+               zmax  = MAX( heup(ji,jj), hmld(ji,jj) )
+               zfact = MAX( 0., fsdepw(ji,jj,jk+1) - zmax ) / 5000._wp
                wsbio4(ji,jj,jk) = wsbio2 + ( 200.- wsbio2 ) * zfact
             END DO
@@ -533,12 +519,12 @@
                zfact = zstep * xdiss(ji,jj,jk)
                !  Part I : Coagulation dependent on turbulence
-               zagg1 = 940.* zfact * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jppoc)
-               zagg2 = 1.054e4 * zfact * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jpgoc)
+               zagg1 = 354.  * zfact * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jppoc)
+               zagg2 = 4452. * zfact * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jpgoc)
 
                ! Part II : Differential settling
 
                !  Aggregation of small into large particles
-               zagg3 = 0.66 * zstep * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jpgoc)
-               zagg4 = 0.e0 * zstep * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jppoc)
+               zagg3 =  4.7 * zstep * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jpgoc)
+               zagg4 =  0.4 * zstep * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jppoc)
 
                zagg   = zagg1 + zagg2 + zagg3 + zagg4
@@ -546,13 +532,14 @@
 
                ! Aggregation of DOC to small particles
-               zaggdoc = ( 80.* trn(ji,jj,jk,jpdoc) + 698. * trn(ji,jj,jk,jppoc) ) *  zfact * trn(ji,jj,jk,jpdoc) 
-               zaggdoc2 = 1.05e4 * zfact * trn(ji,jj,jk,jpgoc) * trn(ji,jj,jk,jpdoc)
+               zaggdoc  = ( 0.83 * trn(ji,jj,jk,jpdoc) + 271. * trn(ji,jj,jk,jppoc) ) * zfact * trn(ji,jj,jk,jpdoc)
+               zaggdoc2 = 1.07e4 * zfact * trn(ji,jj,jk,jpgoc) * trn(ji,jj,jk,jpdoc)
+               zaggdoc3 =   0.02 * ( 16706. * trn(ji,jj,jk,jppoc) + 231. * trn(ji,jj,jk,jpdoc) ) * zstep * trn(ji,jj,jk,jpdoc)
 
                !  Update the trends
-               tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) - zagg + zaggdoc
+               tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) - zagg + zaggdoc + zaggdoc3
                tra(ji,jj,jk,jpgoc) = tra(ji,jj,jk,jpgoc) + zagg + zaggdoc2
                tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) - zaggfe
                tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + zaggfe
-               tra(ji,jj,jk,jpdoc) = tra(ji,jj,jk,jpdoc) - zaggdoc - zaggdoc2
+               tra(ji,jj,jk,jpdoc) = tra(ji,jj,jk,jpdoc) - zaggdoc - zaggdoc2 - zaggdoc3
                !
             END DO
